import { driver, auth, types, isInt, integer, int } from 'neo4j-driver';

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

var ConfigurationManager = /*#__PURE__*/function () {
  function ConfigurationManager() {
    this.databaseUrl = '';
    this.databaseUser = '';
    this.databasePassword = '';
  }

  ConfigurationManager.getInstance = function getInstance() {
    if (!ConfigurationManager.instance) {
      ConfigurationManager.instance = new ConfigurationManager();
    }

    return ConfigurationManager.instance;
  };

  var _proto = ConfigurationManager.prototype;

  _proto.setConfiguration = function setConfiguration(_ref) {
    var databaseUrl = _ref.databaseUrl,
        databaseUser = _ref.databaseUser,
        databasePassword = _ref.databasePassword;
    this.databaseUrl = databaseUrl;
    this.databaseUser = databaseUser;
    this.databasePassword = databasePassword;
  };

  return ConfigurationManager;
}();

/**
 * Set the configuration for Neo4TS to connec to to the DB using the Neo4J Driver
 * @param {Configuration} configuration
 */

var setConfiguration = function setConfiguration(configuration) {
  var manager = ConfigurationManager.getInstance();
  manager.setConfiguration(configuration);
};
/**
 * Get the configuration used for Neo4TS
 * @returns {ConfigurationManager}
 */

var getConfiguration = function getConfiguration() {
  return ConfigurationManager.getInstance();
};

var DriverAdapter = /*#__PURE__*/function () {
  function DriverAdapter() {
    this.configManager = getConfiguration();
    this.driver = this.openNewDriver();
  }

  DriverAdapter.getInstance = function getInstance() {
    if (!DriverAdapter.instance) {
      DriverAdapter.instance = new DriverAdapter();
    }

    return DriverAdapter.instance;
  }
  /**
   * Check if the Driver connection to DB is open
   * @returns {boolean}
   */
  ;

  var _proto = DriverAdapter.prototype;

  _proto.isDriverOpen = function isDriverOpen() {
    return this.driver != null;
  }
  /**
   * Open a new Driver connection to DB using the Neo4TS Configuration Manager, data to connect
   * @returns {Neo4JDriver.Driver}
   */
  ;

  _proto.openNewDriver = function openNewDriver() {
    var url = this.configManager.databaseUrl;
    var user = this.configManager.databaseUser;
    var pass = this.configManager.databasePassword;
    this.driver = driver(url, auth.basic(user, pass));
    return this.driver;
  }
  /**
   * Get a Driver connection, if it's not open it will open a new connection and return it
   * @returns {Neo4JDriver.Driver}
   */
  ;

  _proto.getDriver = function getDriver() {
    if (this.driver) {
      return this.driver;
    }

    var driver = this.openNewDriver();
    return driver;
  }
  /**
   * Close the driver connection
   */
  ;

  _proto.closeDriver = function closeDriver() {
    if (this.driver) {
      this.driver.close();
      this.driver = null;
    }
  };

  return DriverAdapter;
}();

var DBExecuter = /*#__PURE__*/function () {
  function DBExecuter() {
    this.driverAdapter = DriverAdapter.getInstance();
  }

  var _proto = DBExecuter.prototype;

  _proto.run = /*#__PURE__*/function () {
    var _run = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(query, parameters) {
      var session, result;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              session = this.getSession();
              result = null;
              _context.prev = 2;
              _context.next = 5;
              return session.run(query, parameters);

            case 5:
              result = _context.sent;
              _context.next = 15;
              break;

            case 8:
              _context.prev = 8;
              _context.t0 = _context["catch"](2);
              console.log(_context.t0);
              console.log('Error caught, Retrying...');
              _context.next = 14;
              return session.run(query, parameters);

            case 14:
              result = _context.sent;

            case 15:
              _context.prev = 15;
              session.close();
              return _context.finish(15);

            case 18:
              return _context.abrupt("return", result);

            case 19:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[2, 8, 15, 18]]);
    }));

    function run(_x, _x2) {
      return _run.apply(this, arguments);
    }

    return run;
  }();

  _proto.getSession = function getSession() {
    return this.driverAdapter.getDriver().session();
  };

  return DBExecuter;
}();

var PRETTY_CHARACTERS = {
  LINE_BREAK: '\n',
  TAB_CHAR: '\t'
};
var MIN_CHARACTERS = {
  LINE_BREAK: ' ',
  TAB_CHAR: ''
};
var RETUNR_KEYWORD = 'RETURN';

var Node = function Node(alias, labels) {
  this.alias = alias;
  this.labels = labels;
  this.isReturnable = true;
  this.isOptional = false;
  this.properties = [];
};

var Relationship = function Relationship(alias, labels, source, target) {
  this.alias = alias;
  this.labels = labels;
  this.source = source;
  this.target = target;
  this.isReturnable = true;
  this.isOptional = false;
};

var DEFAULT_FILTER_GROUP = 'Neo4TS_Main_Group';
var PropertyTypes;

(function (PropertyTypes) {
  PropertyTypes["INTEGER"] = "integer";
  PropertyTypes["FLOAT"] = "float";
  PropertyTypes["BOOLEAN"] = "boolean";
  PropertyTypes["STRING"] = "string";
  PropertyTypes["DATE"] = "date";
  PropertyTypes["TIME"] = "time";
  PropertyTypes["DATETIME"] = "datetime";
  PropertyTypes["ARRAY"] = "array";
})(PropertyTypes || (PropertyTypes = {}));

var Condition;

(function (Condition) {
  Condition["EQUAL"] = "equal";
  Condition["DIFFERENT"] = "different";
  Condition["CONTAINS"] = "contains";
  Condition["NOTCONTAINS"] = "notcontains";
  Condition["STARTS"] = "starts";
  Condition["ENDS"] = "ends";
  Condition["GREATER"] = "greater";
  Condition["GREATEREQUAL"] = "greaterequal";
  Condition["LOWER"] = "lower";
  Condition["LOWEREQUAL"] = "lowerequal";
  Condition["IN"] = "in";
  Condition["REVERSEIN"] = "reversein";
})(Condition || (Condition = {}));

var Operator;

(function (Operator) {
  Operator[Operator["AND"] = 0] = "AND";
  Operator[Operator["OR"] = 1] = "OR";
  Operator[Operator["XOR"] = 2] = "XOR";
  Operator[Operator["NOT"] = 3] = "NOT";
})(Operator || (Operator = {}));

var Property = function Property(alias, type, value) {
  this.alias = alias;
  this.type = type;
  this.value = value;
  this.condition = Condition.EQUAL;
  this.operator = Operator.AND;
  this.isReturnable = true;
  this.isFilter = true;
  this.filterGroups = [DEFAULT_FILTER_GROUP];
};

var Neo4jValueFactory = function Neo4jValueFactory(property) {
  if (property.value instanceof Date) {
    switch (property.type) {
      case PropertyTypes.DATE:
        return new types.Date(property.value.getFullYear(), property.value.getMonth() + 1, property.value.getDate());

      case PropertyTypes.TIME:
        return new types.Time(property.value.getHours(), property.value.getMinutes(), property.value.getSeconds() * 0, property.value.getMilliseconds() * 1000000, property.value.getTimezoneOffset() * 60);

      case PropertyTypes.DATETIME:
      default:
        return new types.DateTime(property.value.getFullYear(), property.value.getMonth() + 1, property.value.getDate(), property.value.getHours(), property.value.getMinutes(), property.value.getSeconds() * 0, property.value.getMilliseconds() * 1000000, property.value.getTimezoneOffset() * 60);
    }
  }

  return property.value;
};

var ParamsHolder = /*#__PURE__*/function () {
  function ParamsHolder() {
    this.paramHolder = {};
    this.valueFactory = Neo4jValueFactory;
  }

  var _proto = ParamsHolder.prototype;

  _proto.addParammeters = function addParammeters(graphEntities) {
    this.paramHolder = {};

    for (var _iterator = _createForOfIteratorHelperLoose(graphEntities), _step; !(_step = _iterator()).done;) {
      var entity = _step.value;
      this.addPropertiesParams(entity);
    }
  };

  _proto.addPropertiesParams = function addPropertiesParams(entity) {
    if (entity.properties && entity.properties.length === 0) return;
    this.paramHolder[entity.alias] = {};

    for (var _iterator2 = _createForOfIteratorHelperLoose(entity.properties || []), _step2; !(_step2 = _iterator2()).done;) {
      var property = _step2.value;
      this.paramHolder[entity.alias][property.alias] = {
        name: this.generateParamName(property),
        value: this.generateParamValue(property)
      };
    }
  };

  _proto.generateParamName = function generateParamName(property) {
    var r = Math.random().toString(36).substring(7);
    var date = new Date();
    return 'p' + Date.now() + date.getMilliseconds() + r + property.alias;
  };

  _proto.generateParamValue = function generateParamValue(property) {
    return this.valueFactory(property);
  };

  _proto.getParamName = function getParamName(entityAlias, propertyAlias) {
    var paramHolder = this.paramHolder[entityAlias];
    if (paramHolder == null) throw new Error('no param found by that entity alias');
    var holder = paramHolder[propertyAlias];
    if (holder == null) throw new Error('no param found by that property alias');
    return holder.name;
  };

  _proto.getParamNameForQuery = function getParamNameForQuery(entityAlias, propertyAlias) {
    var paramName = this.getParamName(entityAlias, propertyAlias);
    return "$" + paramName;
  };

  _proto.getParamsForDatabaseUse = function getParamsForDatabaseUse() {
    var params = {};

    for (var _i = 0, _Object$entries = Object.entries(this.paramHolder); _i < _Object$entries.length; _i++) {
      var _Object$entries$_i = _Object$entries[_i],
          propertyHolder = _Object$entries$_i[1];

      for (var _i2 = 0, _Object$entries2 = Object.entries(propertyHolder); _i2 < _Object$entries2.length; _i2++) {
        var _Object$entries2$_i = _Object$entries2[_i2],
            paramDto = _Object$entries2$_i[1];
        params[paramDto.name] = paramDto.value;
      }
    }

    return params;
  };

  return ParamsHolder;
}();

function MapToJson(map) {
  var newJson = null;
  var tempJson = null;

  if (map.hasOwnProperty('records')) {
    if (map.records.length > 0) {
      newJson = {
        rows: []
      };
      map.records.forEach(function (record) {
        if (record.hasOwnProperty('keys') && record.hasOwnProperty('_fields') && record.hasOwnProperty('_fieldLookup')) {
          tempJson = {};
          record.keys.forEach(function (key) {
            var recordValue = record._fields[record._fieldLookup[key]];
            tempJson[key] = getValue(recordValue);
          });
          newJson.rows.push(tempJson);
        }
      });
    }
  }

  return newJson;
}
function getValue(recordValue) {
  var isNode = false;
  var isRelationship = false;
  var isArray = false;
  var isObject = false;
  var isInteger = false;
  var isBool = false;
  var tempObj = null;
  var nodeKeys = null;

  if (recordValue) {
    isNode = recordValue.hasOwnProperty('identity') && recordValue.hasOwnProperty('properties') && recordValue.hasOwnProperty('labels');
    isRelationship = recordValue.hasOwnProperty('identity') && recordValue.hasOwnProperty('properties') && recordValue.hasOwnProperty('start') && recordValue.hasOwnProperty('end') && recordValue.hasOwnProperty('type');
    isArray = Array.isArray(recordValue);
    isObject = typeof recordValue === 'object';
    isInteger = isInt(recordValue);

    if (recordValue === 'true' || recordValue === 'false') {
      isBool = true;
    }
  }

  if (isNode || isRelationship || isArray || isObject && !isInteger || isBool) {
    if (isNode) {
      tempObj = {};
      nodeKeys = Object.keys(recordValue.properties);
      nodeKeys.forEach(function (nodeKey) {
        tempObj[nodeKey] = getValue(recordValue.properties[nodeKey]);
      });
    } else if (isRelationship) {
      tempObj = {};
      nodeKeys = Object.keys(recordValue.properties);
      nodeKeys.forEach(function (nodeKey) {
        tempObj[nodeKey] = getValue(recordValue.properties[nodeKey]);
      });
    } else if (isArray) {
      tempObj = [];
      recordValue.forEach(function (element) {
        tempObj.push(getValue(element));
      });
    } else if (isObject) {
      tempObj = {};
      nodeKeys = Object.keys(recordValue);
      nodeKeys.forEach(function (nodeKey) {
        tempObj[nodeKey] = getValue(recordValue[nodeKey]);
      });
    } else if (isBool) {
      if (recordValue === 'true') {
        tempObj = true;
      } else if (recordValue === 'false') {
        tempObj = false;
      }
    }
  } else {
    if (isInteger) {
      if (integer.inSafeRange(recordValue)) tempObj = int(recordValue).toNumber();else tempObj = recordValue.toString();
    } else tempObj = recordValue;
  }

  return tempObj;
}

var mapToDto = function mapToDto(map, originalPattern) {
  var finalRes = [];

  for (var _iterator = _createForOfIteratorHelperLoose(map.records), _step; !(_step = _iterator()).done;) {
    var record = _step.value;
    finalRes.push(mapEntities(record, originalPattern));
  }

  return finalRes;
};

var mapEntities = function mapEntities(record, originalPattern) {
  var abstraction = {};
  var onlyReturnables = originalPattern.filter(function (e) {
    return e.isReturnable;
  });

  for (var _iterator2 = _createForOfIteratorHelperLoose(onlyReturnables), _step2; !(_step2 = _iterator2()).done;) {
    var entity = _step2.value;
    var resultEnt = record.get(entity.alias);
    abstraction[entity.alias] = mapGraphEntities(resultEnt, entity);
  }

  return abstraction;
};

var mapGraphEntities = function mapGraphEntities(recordValue, originalEntity) {
  if (isNode(recordValue) && originalEntity instanceof Node) {
    return mapGraphEntityFromRecord(recordValue);
  } else if (isRelationship(recordValue) && originalEntity instanceof Relationship) {
    return mapGraphRelationshipFromRecord(recordValue, originalEntity);
  }

  throw new Error("DB results don't match the pattern defined");
};

var isNode = function isNode(recordValue) {
  return recordValue.hasOwnProperty('identity') && recordValue.hasOwnProperty('properties') && recordValue.hasOwnProperty('labels');
};

var isRelationship = function isRelationship(recordValue) {
  return recordValue.hasOwnProperty('identity') && recordValue.hasOwnProperty('properties') && recordValue.hasOwnProperty('start') && recordValue.hasOwnProperty('end') && recordValue.hasOwnProperty('type');
};

var mapGraphEntityFromRecord = function mapGraphEntityFromRecord(recordNode) {
  var graphent = {
    id: getId(recordNode),
    labels: recordNode.labels,
    properties: mapGraphProperties(recordNode)
  };
  return graphent;
};

var mapGraphRelationshipFromRecord = function mapGraphRelationshipFromRecord(recordRelationship, originalRel) {
  var graphRel = {
    id: getId(recordRelationship),
    labels: [recordRelationship.type],
    from: originalRel.source.alias,
    to: originalRel.target.alias,
    properties: mapGraphProperties(recordRelationship)
  };
  return graphRel;
};

var getId = function getId(recordValue) {
  var identity = recordValue.identity;
  var id;

  if (isInt(identity) && integer.inSafeRange(identity)) {
    id = int(identity).toNumber();
  } else {
    id = identity.toString();
  }

  return id;
};

var mapGraphProperties = function mapGraphProperties(recordValue) {
  var props = {};

  if (recordValue.properties && typeof recordValue.properties === 'object' && Object.keys(recordValue.properties).length > 0) {
    var keys = Object.keys(recordValue.properties);

    for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
      var key = _keys[_i];
      props[key] = getValue(recordValue.properties[key]);
    }
  }

  return props;
};

var DBAction = /*#__PURE__*/function () {
  function DBAction(entities, adapter) {
    this.LINE_BREAK = MIN_CHARACTERS.LINE_BREAK;
    this.TAB_CHAR = MIN_CHARACTERS.TAB_CHAR;
    this.RETURN_KEYWORD = RETUNR_KEYWORD;

    this.returnBuilderCallBack = function () {
      return '';
    };

    this.isFunctionOverrided = false;
    this.entities = [];
    this.paramsHolder = new ParamsHolder();
    this.setEntities(entities);
    if (adapter) this.executerAdapter = adapter;else this.executerAdapter = new DBExecuter();
  }
  /**
   * Return a params Object that you can inject to a Neo4J Database Driver, or to export it as JSON
   * @returns {Records<string, any>}
   */


  var _proto = DBAction.prototype;

  _proto.getParamsForDatabaseUse = function getParamsForDatabaseUse() {
    var paramHolder = this.getParamHolder();
    return paramHolder.getParamsForDatabaseUse();
  }
  /**
   * Converts the entities and returns a minified version of the cypher query in string form.
   * @returns {string}
   */
  ;

  _proto.getQuery = function getQuery() {
    this.LINE_BREAK = MIN_CHARACTERS.LINE_BREAK;
    this.TAB_CHAR = MIN_CHARACTERS.TAB_CHAR;
    return this.generateQuery();
  }
  /**
   * Converts the entities and return a prettified version of the cypher query in string form.
   * @returns
   */
  ;

  _proto.getPrettyQuery = function getPrettyQuery() {
    this.LINE_BREAK = PRETTY_CHARACTERS.LINE_BREAK;
    this.TAB_CHAR = PRETTY_CHARACTERS.TAB_CHAR;
    return this.generateQuery();
  }
  /**
   * Set new entities to the DBAction this will also auto generate a new set of params to use.
   * @param {IGraphEntity[]} entities - a set of entities used to build the cypher query
   * @returns
   */
  ;

  _proto.setEntities = function setEntities(entities) {
    this.entities = entities;
    this.setParameters();
    return this;
  }
  /**
   * Override the "return" cypher generator function, you can set a new string cypher function to inject
   * custom behaviour at the return part of your query
   * @example
   * // this will return a cypher like:
   * // match(n) return 'hello world';
   * action.overrideReturnAction( () => '\'hello world\'' ).getQuery();
   * @param callBack - This callback will be executed when Neo4TS generates the return part of the cypher query
   * @returns
   */
  ;

  _proto.overrideReturnAction = function overrideReturnAction(callBack) {
    this.isFunctionOverrided = true;
    this.returnBuilderCallBack = callBack;
    return this;
  }
  /**
   * Returns the param Holder which contains the parameters that will be used by this aciton.
   * @returns
   */
  ;

  _proto.getParamHolder = function getParamHolder() {
    return this.paramsHolder;
  }
  /**
   * It will execute the action into the Data Base, using Neo4J Driver to connect and execute the cypher, using the entities assigned to this action
   * After executing the action it will try to parse the result to a more friendly JSON form.
   * @returns
   */
  ;

  _proto.execute =
  /*#__PURE__*/
  function () {
    var _execute = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee() {
      var rawRes;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this.executeRaw();

            case 2:
              rawRes = _context.sent;

              if (!this.isFunctionOverrided) {
                _context.next = 5;
                break;
              }

              return _context.abrupt("return", MapToJson(rawRes));

            case 5:
              return _context.abrupt("return", mapToDto(rawRes, this.entities));

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function execute() {
      return _execute.apply(this, arguments);
    }

    return execute;
  }();

  _proto.buildAfterQueryReturnDecorators = function buildAfterQueryReturnDecorators(params) {
    if (params) return '';
    return '';
  };

  _proto.buildQueryReturn = function buildQueryReturn(params) {
    var res = [this.RETURN_KEYWORD, this.LINE_BREAK, this.returnBuilderCallBack(this.entities, params)].join('');
    return res;
  };

  _proto.generateQuery = function generateQuery() {
    var params = this.getParamHolder();
    var body = this.buildQueryBody(params);
    var returnPart = this.buildQueryReturn(params);
    var decos = this.buildAfterQueryReturnDecorators(params);
    var query = [body, returnPart, decos ? this.LINE_BREAK : '', decos].join('');
    return query;
  };

  _proto.setParameters = function setParameters() {
    this.paramsHolder.addParammeters(this.entities);
  };

  return DBAction;
}();

var generateSkip = function generateSkip(page, size) {
  if (page && size) {
    return "SKIP " + page * size;
  }

  return '';
};
var generateLimit = function generateLimit(size) {
  if (size) {
    return "LIMIT " + size;
  }

  return '';
};
var generateSkipAndLimit = function generateSkipAndLimit(page, size) {
  var query = '';

  if (page && size && page > 0 && size > 0) {
    query += generateSkip(page, size) + ' ';
  }

  if (size && size > 0) {
    query += generateLimit(size);
  }

  return query;
};

var simpleReturnBuilder = function simpleReturnBuilder(entities) {
  var query = '';

  for (var _iterator = _createForOfIteratorHelperLoose(entities), _step; !(_step = _iterator()).done;) {
    var entity = _step.value;

    if (entity.isReturnable) {
      query += query ? ', ' : '';
      query += entity.alias;
    }
  }

  return query;
};

var CypherBuilder = /*#__PURE__*/function () {
  function CypherBuilder(LINE_BREAK, TAB_CHAR) {
    this.LINE_BREAK = LINE_BREAK;
    this.TAB_CHAR = TAB_CHAR;
    this.entities = [];
    this.params = new ParamsHolder();
  }

  var _proto = CypherBuilder.prototype;

  _proto.getCypher = function getCypher(entities, params) {
    this.entities = entities;
    this.params = params;

    for (var _len = arguments.length, extraParams = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
      extraParams[_key - 2] = arguments[_key];
    }

    var res = this.buildCypher.apply(this, extraParams);
    if (res) return res + this.LINE_BREAK;else return '';
  };

  _proto.setLineBreak = function setLineBreak(lineBreak) {
    this.LINE_BREAK = lineBreak;
  };

  _proto.setTabChar = function setTabChar(tabchar) {
    this.TAB_CHAR = tabchar;
  };

  return CypherBuilder;
}();

var filterConditionFactory = function filterConditionFactory(property, propertyName, paramValue) {
  switch (property.condition) {
    case Condition.DIFFERENT:
      return propertyName + " <> " + paramValue;

    case Condition.CONTAINS:
      if (property.type !== PropertyTypes.STRING) {
        throw new Error('Contains is an operator only available on strings');
      }

      return "toLower(" + propertyName + ") CONTAINS " + paramValue;

    case Condition.NOTCONTAINS:
      if (property.type !== PropertyTypes.STRING) {
        throw new Error('Contains is an operator only available on strings');
      }

      return "(not ( toLower(" + propertyName + ") CONTAINS toLower(" + paramValue + ") ))";

    case Condition.STARTS:
      if (property.type !== PropertyTypes.STRING) {
        throw new Error('Contains is an operator only available on strings');
      }

      return "toLower(" + propertyName + ") STARTS WITH toLower(" + paramValue + ")";

    case Condition.ENDS:
      if (property.type !== PropertyTypes.STRING) {
        throw new Error('Contains is an operator only available on strings');
      }

      return "toLower(" + propertyName + ") ENDS WITH toLower(" + paramValue + ")";

    case Condition.GREATER:
      if (property.type !== PropertyTypes.INTEGER && property.type !== PropertyTypes.FLOAT) {
        throw new Error('Greater is an operator only available on numeric types');
      }

      return propertyName + " > " + paramValue;

    case Condition.GREATEREQUAL:
      if (property.type !== PropertyTypes.INTEGER && property.type !== PropertyTypes.FLOAT && property.type !== PropertyTypes.DATE && property.type !== PropertyTypes.TIME && property.type !== PropertyTypes.DATETIME) {
        throw new Error('Greater or Equal (>=) is an operator only available on numeric or date types');
      }

      return propertyName + " >= " + paramValue;

    case Condition.LOWER:
      if (property.type !== PropertyTypes.INTEGER && property.type !== PropertyTypes.FLOAT) {
        throw new Error('LOWER is an operator only available on numeric types');
      }

      return propertyName + " < " + paramValue;

    case Condition.LOWEREQUAL:
      if (property.type !== PropertyTypes.INTEGER && property.type !== PropertyTypes.FLOAT && property.type !== PropertyTypes.DATE && property.type !== PropertyTypes.TIME && property.type !== PropertyTypes.DATETIME) {
        throw new Error('Lower or Equal (<=) is an operator only available on numeric or date types');
      }

      return propertyName + " <= " + paramValue;

    case Condition.IN:
      return paramValue + " IN " + propertyName;

    case Condition.REVERSEIN:
      return propertyName + " IN " + paramValue;

    case Condition.EQUAL:
    default:
      return propertyName + " = " + paramValue;
  }
};

var operatorFactory = function operatorFactory(property) {
  switch (property.operator) {
    case Operator.OR:
      return 'OR';

    case Operator.NOT:
      return 'NOT';

    case Operator.XOR:
      return 'XOR';

    case Operator.AND:
    default:
      return 'AND';
  }
};

var WhereServiceBuilder = /*#__PURE__*/function (_CypherBuilder) {
  _inheritsLoose(WhereServiceBuilder, _CypherBuilder);

  function WhereServiceBuilder(lineBreak, tabChar) {
    var _this;

    _this = _CypherBuilder.call(this, lineBreak, tabChar) || this;
    _this.doesFirstPass = false;
    _this.filterAndConditionFactory = filterConditionFactory;
    _this.operatorFactory = operatorFactory;
    _this.entities = [];
    _this.params = new ParamsHolder();
    return _this;
  }

  var _proto = WhereServiceBuilder.prototype;

  _proto.buildCypher = function buildCypher() {
    var query = this.generateFiltersQueryString();
    if (query.length > 0) query = this.appendPrefix(query);
    return query;
  };

  _proto.generateFiltersQueryString = function generateFiltersQueryString() {
    var query = '';
    this.doesFirstPass = false;

    for (var _iterator = _createForOfIteratorHelperLoose(this.entities), _step; !(_step = _iterator()).done;) {
      var entity = _step.value;
      query += this.generateFiltersStringForEntity(entity);
    }

    return query;
  };

  _proto.generateFiltersStringForEntity = function generateFiltersStringForEntity(entity) {
    var query = '';

    for (var _iterator2 = _createForOfIteratorHelperLoose(entity.properties || []), _step2; !(_step2 = _iterator2()).done;) {
      var property = _step2.value;
      query += this.generateFiltersStringForProperty(property, entity);
    }

    return query;
  };

  _proto.generateFiltersStringForProperty = function generateFiltersStringForProperty(property, parentEntity) {
    var query = '';
    query += this.generateOperator(property);
    query += this.generateFilterWithCondition(property, parentEntity);
    return query;
  };

  _proto.generateOperator = function generateOperator(property) {
    var operator = '';

    if (!this.doesFirstPass) {
      if (property.operator !== Operator.AND) {
        throw new Error("In where filter, the first filte should be always an 'AND' operator");
      }

      operator += this.TAB_CHAR;
      this.doesFirstPass = true;
    } else {
      operator += this.LINE_BREAK + this.TAB_CHAR + this.operatorFactory(property) + ' ';
    }

    return operator;
  };

  _proto.generateFilterWithCondition = function generateFilterWithCondition(property, parentEntity) {
    var propertyName = this.generatePropertyName(property, parentEntity);
    var paramValue = this.params.getParamNameForQuery(parentEntity.alias, property.alias);
    return this.filterAndConditionFactory(property, propertyName, paramValue);
  };

  _proto.generatePropertyName = function generatePropertyName(property, parentEntity) {
    return parentEntity.alias + "." + property.alias;
  };

  _proto.appendPrefix = function appendPrefix(query) {
    if (query) return 'WHERE' + this.LINE_BREAK + query;
    return '';
  };

  return WhereServiceBuilder;
}(CypherBuilder);

var buildNodeSelect = function buildNodeSelect(node, usedNodes) {
  var found = usedNodes.find(function (n) {
    return n === node;
  });
  var alias = node.alias || '';

  if (found) {
    return "(" + alias + ")";
  }

  usedNodes.push(node);
  var inner = node.id ? " {ptSystemNodeId: '" + node.id + "'}" : '';
  var labels = node.labels.length > 0 ? ":" + node.labels.join(':') : '';
  return "(" + alias + labels + inner + ")";
};
var buildRelSelect = function buildRelSelect(relationship) {
  var alias = relationship.alias || '';
  var inner = relationship.id ? " {ptSystemrelationshipId: '" + relationship.id + "'}" : '';
  var labels = relationship.labels.length > 0 ? ":" + relationship.labels.join(':') : '';
  return "[" + alias + labels + inner + "]";
};

var EntitiesMatchBuiler = /*#__PURE__*/function (_CypherBuilder) {
  _inheritsLoose(EntitiesMatchBuiler, _CypherBuilder);

  function EntitiesMatchBuiler() {
    var _this;

    _this = _CypherBuilder.apply(this, arguments) || this;
    _this.usedNodes = [];
    _this.PREFIX_EMPTY = ',';
    _this.PREFIX_NON_EMPTY = '';
    _this.MATCH_BREAK = ',';
    return _this;
  }

  var _proto = EntitiesMatchBuiler.prototype;

  _proto.getUsedNode = function getUsedNode() {
    return this.usedNodes;
  };

  _proto.buildCypher = function buildCypher(usedNodes) {
    if (usedNodes === void 0) {
      usedNodes = [];
    }

    this.usedNodes = usedNodes;
    var rels = this.entities.filter(function (e) {
      return e instanceof Relationship;
    });
    var nodes = this.entities.filter(function (e) {
      return e instanceof Node;
    });
    var relsMatch = this.buildRelsMatch(rels);
    var nodesMatch = this.buildNodesMatch(nodes);
    var query = this.prepareQuery(nodesMatch, relsMatch);
    query = this.attachMatch(query).trim();
    return query;
  };

  _proto.buildRelsMatch = function buildRelsMatch(relationships) {
    var relsMatch = '';

    for (var _iterator = _createForOfIteratorHelperLoose(relationships), _step; !(_step = _iterator()).done;) {
      var rel = _step.value;
      var prefix = relsMatch !== '' ? this.getEmptyPrefix() : this.getNonEmptyPrefix();
      relsMatch += prefix + this.buildRelMatch(rel);
    }

    return relsMatch;
  };

  _proto.buildRelMatch = function buildRelMatch(rel) {
    var sourceString = buildNodeSelect(rel.source, this.usedNodes);
    var targetString = buildNodeSelect(rel.target, this.usedNodes);
    var relString = buildRelSelect(rel);
    var relsMatch = sourceString + "-" + relString + "->" + targetString;
    return relsMatch;
  };

  _proto.buildNodesMatch = function buildNodesMatch(nodes) {
    var _this2 = this;

    var nodesMatch = '';

    var _loop = function _loop() {
      var node = _step2.value;

      if (!_this2.usedNodes.some(function (n) {
        return n === node;
      })) {
        var prefix = nodesMatch !== '' ? _this2.getEmptyPrefix() : _this2.getNonEmptyPrefix();
        nodesMatch += prefix + _this2.buildNodeMatch(node);
      }
    };

    for (var _iterator2 = _createForOfIteratorHelperLoose(nodes), _step2; !(_step2 = _iterator2()).done;) {
      _loop();
    }

    return nodesMatch;
  };

  _proto.buildNodeMatch = function buildNodeMatch(node) {
    var nodeString = buildNodeSelect(node, this.usedNodes);
    var nodeMatch = nodeString;
    return nodeMatch;
  };

  _proto.prepareQuery = function prepareQuery(nodesMatch, relsMatch) {
    var query = nodesMatch;

    if (nodesMatch && relsMatch) {
      query += this.MATCH_BREAK + this.LINE_BREAK;
    }

    query += relsMatch;
    return query;
  };

  _proto.attachMatch = function attachMatch(query) {
    if (!query) return '';
    return 'MATCH' + this.LINE_BREAK + query;
  };

  _proto.getEmptyPrefix = function getEmptyPrefix() {
    return this.PREFIX_EMPTY + this.LINE_BREAK + this.TAB_CHAR;
  };

  _proto.getNonEmptyPrefix = function getNonEmptyPrefix() {
    return this.PREFIX_NON_EMPTY + this.TAB_CHAR;
  };

  return EntitiesMatchBuiler;
}(CypherBuilder);

var OptionalEntitiesMatchBuilder = /*#__PURE__*/function (_EntitiesMatchBuiler) {
  _inheritsLoose(OptionalEntitiesMatchBuilder, _EntitiesMatchBuiler);

  function OptionalEntitiesMatchBuilder(lineBreak, tabChar) {
    var _this;

    _this = _EntitiesMatchBuiler.call(this, lineBreak, tabChar) || this;
    _this.PREFIX_EMPTY = 'OPTIONAL MATCH ';
    _this.PREFIX_NON_EMPTY = 'OPTIONAL MATCH ';
    _this.MATCH_BREAK = '';
    _this.whereService = new WhereServiceBuilder(lineBreak, tabChar);
    return _this;
  }

  var _proto = OptionalEntitiesMatchBuilder.prototype;

  _proto.attachMatch = function attachMatch(query) {
    return query;
  };

  _proto.getEmptyPrefix = function getEmptyPrefix() {
    return this.LINE_BREAK + this.PREFIX_EMPTY;
  };

  _proto.getNonEmptyPrefix = function getNonEmptyPrefix() {
    return this.PREFIX_NON_EMPTY;
  };

  _proto.buildNodeMatch = function buildNodeMatch(node) {
    var wherePart = this.getWherePart([node]);

    var query = _EntitiesMatchBuiler.prototype.buildNodeMatch.call(this, node);

    if (query && wherePart) return query + this.LINE_BREAK + wherePart;
    return query;
  };

  _proto.buildRelMatch = function buildRelMatch(rel) {
    var entities = [rel];
    if (!this.usedNodes.some(function (n) {
      return n === rel.target;
    })) entities.push(rel.target);
    if (!this.usedNodes.some(function (n) {
      return n === rel.source;
    })) entities.push(rel.source);
    var wherePart = this.getWherePart(entities);

    var query = _EntitiesMatchBuiler.prototype.buildRelMatch.call(this, rel);

    if (query && wherePart) return query + this.LINE_BREAK + wherePart;
    return query;
  };

  _proto.getWherePart = function getWherePart(entities) {
    var where = this.whereService.getCypher(entities, this.params);
    return where;
  };

  return OptionalEntitiesMatchBuilder;
}(EntitiesMatchBuiler);

var SelectBuilder = /*#__PURE__*/function (_CypherBuilder) {
  _inheritsLoose(SelectBuilder, _CypherBuilder);

  function SelectBuilder(lineBreak, tabChar) {
    var _this;

    _this = _CypherBuilder.call(this, lineBreak, tabChar) || this;
    _this.matchBuilder = new EntitiesMatchBuiler(lineBreak, tabChar);
    _this.optionalMatchBuilder = new OptionalEntitiesMatchBuilder(lineBreak, tabChar);
    _this.whereBuilder = new WhereServiceBuilder(lineBreak, tabChar);
    return _this;
  }

  var _proto = SelectBuilder.prototype;

  _proto.buildCypher = function buildCypher() {
    var nonOptionalEntities = this.entities.filter(function (e) {
      return !e.isOptional;
    });
    var optionalEntities = this.entities.filter(function (e) {
      return e.isOptional;
    });
    var usedEntities = [];
    var query = '';
    query += this.matchBuilder.getCypher(nonOptionalEntities, this.params, usedEntities);
    usedEntities = this.matchBuilder.getUsedNode();
    var wherePartForNormal = this.whereBuilder.getCypher(nonOptionalEntities, this.params);
    if (wherePartForNormal) query += wherePartForNormal;
    query += this.optionalMatchBuilder.getCypher(optionalEntities, this.params, usedEntities);
    usedEntities = this.optionalMatchBuilder.getUsedNode();
    return query.slice(0, -1);
  };

  return SelectBuilder;
}(CypherBuilder);

var RetrieveBuilder = /*#__PURE__*/function (_DBAction) {
  _inheritsLoose(RetrieveBuilder, _DBAction);

  function RetrieveBuilder(entities, adapter) {
    var _this;

    _this = _DBAction.call(this, entities, adapter) || this;
    _this.returnBuilderCallBack = simpleReturnBuilder;
    return _this;
  }

  var _proto = RetrieveBuilder.prototype;

  _proto.buildQueryBody = function buildQueryBody(params) {
    var selectBuilder = new SelectBuilder(this.LINE_BREAK, this.TAB_CHAR);
    var query = this.buildSelect(params, selectBuilder);
    return query;
  };

  _proto.buildSelect = function buildSelect(params, selectBuilder) {
    return selectBuilder.getCypher(this.entities, params);
  };

  _proto.buildAfterQueryReturnDecorators = function buildAfterQueryReturnDecorators() {
    return generateSkipAndLimit(this.page, this.size);
  };

  _proto.executeRaw = function executeRaw() {
    var query = this.getQuery();
    var params = this.getParamsForDatabaseUse();
    return this.executerAdapter.run(query, params);
  };

  return RetrieveBuilder;
}(DBAction);

var CypherActions = /*#__PURE__*/function () {
  function CypherActions() {}

  var _proto = CypherActions.prototype;

  _proto.generateRetrieveAction = function generateRetrieveAction(entities, page, size) {
    var retrieve = new RetrieveBuilder(entities);
    retrieve.page = page;
    retrieve.size = size;
    return retrieve;
  };

  return CypherActions;
}();

var getId$1 = function getId(graphEntity) {
  var id;
  var idValue = null;

  if (graphEntity.id) {
    idValue = graphEntity.id;
  } else if (graphEntity.properties) {
    idValue = graphEntity.properties.id || graphEntity.properties.ptSystemNodeId || graphEntity.properties.ptSystemRelationshipId;
  }

  if (idValue != null) {
    if (typeof idValue === 'object' && idValue.value) {
      id = idValue.value;
    } else if (typeof idValue == 'string' || typeof idValue == 'number') {
      id = idValue;
    }
  }

  return id;
};
var getLabels = function getLabels(graphEntity) {
  if (graphEntity.labels && graphEntity.label) {
    throw new Error('Two identifiers for labels were found, you should use one of them (label or labels) not both');
  }

  if (graphEntity.labels) {
    return getListOfLabels(graphEntity.labels);
  }

  if (graphEntity.label) {
    return getListOfLabels(graphEntity.label);
  }

  return [];
};

var getListOfLabels = function getListOfLabels(labels) {
  if (typeof labels === 'string') {
    return [labels];
  } else {
    return labels;
  }
};

var pushGroupToAllProperties = function pushGroupToAllProperties(properties, newGroupName) {
  for (var index in properties) {
    var property = properties[index];

    if (property.group && property.group.length > 0) {
      property.group = newGroupName + '.' + property.group;
    } else {
      property.group = newGroupName;
    }
  }
};

var validateGraphEntity = function validateGraphEntity(entity) {
  if (entity.label && entity.labels) {
    throw new Error('A graph entity can not have label and labels, just use one');
  }

  return validateGraphRelationship(entity);
};
var validateGraphRelationship = function validateGraphRelationship(relationship) {
  var from = relationship.from || relationship.source;
  var to = relationship.to || relationship.target;
  if (!from && !to) return true;

  if (from && !to) {
    throw new Error('Relationship has a source but no target');
  }

  if (!from && to) {
    throw new Error('Relationship has a target but no source');
  }

  return true;
};

var OperatorFactory = function OperatorFactory(value) {
  switch (value.toLowerCase()) {
    case 'and':
      return Operator.AND;

    case 'or':
      return Operator.OR;

    case 'xor':
      return Operator.XOR;

    case 'not':
      return Operator.NOT;

    default:
      return Operator.AND;
  }
};

var PropertyConditionFactory = function PropertyConditionFactory(value) {
  switch (value.toLowerCase()) {
    case 'equal':
    case '=':
      return Condition.EQUAL;

    case 'different':
    case '<>':
    case '!=':
      return Condition.DIFFERENT;

    case 'contains':
      return Condition.CONTAINS;

    case 'not contains':
    case 'notcontains':
    case '!contains':
      return Condition.NOTCONTAINS;

    case 'starts':
    case 'starts with':
      return Condition.STARTS;

    case 'ends':
    case 'ends with':
      return Condition.ENDS;

    case 'greater':
    case '>':
      return Condition.GREATER;

    case 'greaterequal':
    case 'greater equal':
    case 'equalgreater':
    case 'equal greater':
    case '>=':
      return Condition.GREATEREQUAL;

    case 'lower':
    case '<':
      return Condition.LOWER;

    case 'lowerequal':
    case 'lower equal':
    case 'equallower':
    case 'equal lower':
    case '<=':
      return Condition.LOWEREQUAL;

    case 'in':
      return Condition.IN;

    case '!in':
    case 'reversein':
    case 'reverse in':
      return Condition.REVERSEIN;

    default:
      throw new Error('the operator you provide is not supported');
  }
};

var validateOneTypeArray = function validateOneTypeArray(dtoarray) {
  if (dtoarray.length > 0) {
    var firstType = typeof dtoarray[0];

    if (!validateAllowdTypes(firstType)) {
      return false;
    }

    var res = true;

    for (var index = 0; index < dtoarray.length; index++) {
      var element = dtoarray[index];

      if (typeof element != firstType) {
        return false;
      }
    }

    return res;
  } else return true;
};

var validateAllowdTypes = function validateAllowdTypes(valuetype) {
  switch (valuetype) {
    case 'number':
      return true;

    case 'boolean':
      return true;

    case 'string':
      return true;

    default:
      return false;
  }
};

var PropertyTypeValueFactory = function PropertyTypeValueFactory(alias, dbprop) {
  var prop;

  switch (dbprop.type) {
    case 'integer':
      prop = new Property(alias, PropertyTypes.INTEGER, parseInt(dbprop.value));
      break;

    case 'number':
    case 'float':
      prop = new Property(alias, PropertyTypes.INTEGER, parseFloat(dbprop.value));
      break;

    case 'boolean':
      switch (typeof dbprop.value) {
        case 'string':
          prop = new Property(alias, PropertyTypes.BOOLEAN, dbprop.value.toLowerCase() === 'true');
          break;

        case 'number':
          prop = new Property(alias, PropertyTypes.BOOLEAN, dbprop.value === 1);
          break;

        case 'boolean':
          prop = new Property(alias, PropertyTypes.BOOLEAN, dbprop.value);
          break;

        default:
          throw new Error('Error in Query Service: Cannot parse value with the type defined');
      }

      break;

    case 'string':
      prop = new Property(alias, PropertyTypes.STRING, dbprop.value + '');
      break;

    case 'date':
      if (dbprop.value instanceof Date) {
        prop = new Property(alias, PropertyTypes.DATE, dbprop.value);
      } else throw Error('Error in Query Service: Cannot parse value with the type defined');

      break;

    case 'datetime':
      if (dbprop.value instanceof Date) {
        prop = new Property(alias, PropertyTypes.DATETIME, dbprop.value);
      } else throw Error('Error in Query Service: Cannot parse value with the type defined');

      break;

    case 'time':
      if (dbprop.value instanceof Date) {
        prop = new Property(alias, PropertyTypes.TIME, dbprop.value);
      } else throw Error('Error in Query Service: Cannot parse value with the type defined');

      break;

    case 'array':
      if (Array.isArray(dbprop.value) && validateOneTypeArray(dbprop.value)) {
        prop = new Property(alias, PropertyTypes.ARRAY, dbprop.value);
      } else throw Error('Error in Query Service: Cannot parse value with the type defined');

      break;

    default:
      throw new Error();
  }

  return prop;
};

var PropertyObjectMapper = /*#__PURE__*/function () {
  function PropertyObjectMapper() {
    this.propertyValueTypeFactory = PropertyTypeValueFactory;
    this.propertyConditionFactory = PropertyConditionFactory;
    this.operatorFactory = OperatorFactory;
  }

  var _proto = PropertyObjectMapper.prototype;

  _proto.getPropertyIfObject = function getPropertyIfObject(alias, dbprop) {
    if (dbprop.type != null && dbprop.value != null) {
      return this.buildObjectPropertyWithTypeAndValue(alias, dbprop);
    } else if (dbprop.type && !dbprop.value || !dbprop.type && dbprop.value) {
      throw new Error("Can't parse a property causevalue or type is null or undefined");
    } else {
      return this.buildObjectPropertyAsJson(alias, dbprop);
    }
  };

  _proto.buildObjectPropertyWithTypeAndValue = function buildObjectPropertyWithTypeAndValue(alias, dbprop) {
    try {
      return this.buildObjectProperty(alias, dbprop);
    } catch (e) {
      throw new Error('error parsing object in PropertyProvider for key: ' + alias);
    }
  };

  _proto.buildObjectProperty = function buildObjectProperty(alias, dbprop) {
    var prop = this.propertyValueTypeFactory(alias, dbprop);
    prop = this.addPropertyDecoratorsFromDto(prop, dbprop);
    return prop;
  };

  _proto.addPropertyDecoratorsFromDto = function addPropertyDecoratorsFromDto(prop, dto) {
    if (dto.condition) {
      prop.condition = this.propertyConditionFactory(dto.condition);
    }

    if (dto.operator) {
      prop.operator = this.operatorFactory(dto.operator);
    }

    if (dto.isReturnable != null && typeof dto.isReturnable == 'boolean') {
      prop.isReturnable = dto.isReturnable;
    }

    if (dto.isFilter != null && typeof dto.isFilter == 'boolean') {
      prop.isFilter = dto.isFilter;
    }

    if (dto.group) {
      prop.filterGroups = this.generateNewFilterGroups(prop, dto.group);
    }

    return prop;
  };

  _proto.buildObjectPropertyAsJson = function buildObjectPropertyAsJson(alias, dbprop) {
    console.warn('WARNING FROM Neo4TS: an object was parsed as a property and converted into json string format', 'object found in: ' + alias);
    return new Property(alias, PropertyTypes.STRING, JSON.stringify(dbprop));
  };

  _proto.generateNewFilterGroups = function generateNewFilterGroups(property, groupsString) {
    var groups = property.filterGroups;
    var newGroups = groupsString.split('.');

    for (var _iterator = _createForOfIteratorHelperLoose(newGroups), _step; !(_step = _iterator()).done;) {
      var newGroup = _step.value;

      if (newGroup && newGroup !== '') {
        groups.push(newGroup);
      } else throw new Error("Error generating filter groups, an invalid group was found");
    }

    return groups;
  };

  return PropertyObjectMapper;
}();

var PropertyMapper = /*#__PURE__*/function () {
  function PropertyMapper() {
    this.propertyObjectMapper = new PropertyObjectMapper();
  }

  var _proto = PropertyMapper.prototype;

  _proto.getPropertiesFromDto = function getPropertiesFromDto(dbdto) {
    var props = [];
    var keys = Object.keys(dbdto);

    for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
      var key = _keys[_i];

      if (!key.includes('ptSystemNodeId') && !key.includes('ptSystemRelationshipId')) {
        if (dbdto[key] != null) {
          //if property is a date object
          if (dbdto[key] instanceof Date) {
            props.push(new Property(key, PropertyTypes.DATETIME, dbdto[key])); //if property is an array
          } else if (Array.isArray(dbdto[key])) {
            if (validateOneTypeArray(dbdto[key])) {
              props.push(new Property(key, PropertyTypes.ARRAY, dbdto[key]));
            } else throw new Error('Array property not valid, arrays can contains only ONE primitive type'); //if property is an object

          } else if (typeof dbdto[key] === 'object') {
            props.push(this.propertyObjectMapper.getPropertyIfObject(key, dbdto[key])); //if property is a primitive type
          } else {
            props.push(this.getPropertyFromValue(key, dbdto[key]));
          }
        }
      }
    }

    return props;
  };

  _proto.getPropertyFromValue = function getPropertyFromValue(alias, dbprop) {
    var prop;

    if (dbprop instanceof Date) {
      return new Property(alias, PropertyTypes.DATETIME, dbprop);
    }

    switch (typeof dbprop) {
      case 'number':
        if (dbprop % 1 === 0) {
          prop = new Property(alias, PropertyTypes.INTEGER, dbprop);
        } else {
          prop = new Property(alias, PropertyTypes.FLOAT, dbprop);
        }

        break;

      case 'boolean':
        prop = new Property(alias, PropertyTypes.BOOLEAN, dbprop);
        break;

      case 'string':
        prop = new Property(alias, PropertyTypes.STRING, dbprop);
        break;

      default:
        throw new Error('A unkow type was found where trying to parse the object properties');
    }

    return prop;
  };

  return PropertyMapper;
}();

var NodeMapper = /*#__PURE__*/function () {
  function NodeMapper() {
    this.propertyMapper = new PropertyMapper();
  }

  var _proto = NodeMapper.prototype;

  _proto.getInputNode = function getInputNode(_ref) {
    var alias = _ref[0],
        graphNode = _ref[1];
    var id = getId$1(graphNode);
    var labels = getLabels(graphNode);

    if (graphNode.isGroup && graphNode.properties) {
      pushGroupToAllProperties(graphNode.properties, alias);
    }

    var node = new Node(alias, labels);
    node.id = id;
    node.properties = graphNode.properties ? this.propertyMapper.getPropertiesFromDto(graphNode.properties) : [];
    node.isReturnable = graphNode.isReturnable != null ? graphNode.isReturnable : true;
    node.isOptional = graphNode.isOptional != null ? graphNode.isOptional : false;
    return node;
  };

  return NodeMapper;
}();

var RelationshipMapper = /*#__PURE__*/function () {
  function RelationshipMapper() {
    this.entitiescreated = [];
    this.propertyMapper = new PropertyMapper();
  }

  var _proto = RelationshipMapper.prototype;

  _proto.getInputRelationShipWithEntities = function getInputRelationShipWithEntities(aliasedRel, entitiescreated) {
    this.entitiescreated = entitiescreated;
    return this.getInputRelationship(aliasedRel);
  };

  _proto.getInputRelationship = function getInputRelationship(_ref) {
    var alias = _ref[0],
        graphRepationship = _ref[1];
    var id = getId$1(graphRepationship);
    var labels = getLabels(graphRepationship);

    if (graphRepationship.isGroup && graphRepationship.properties) {
      pushGroupToAllProperties(graphRepationship.properties, alias);
    }

    var _this$getSourceAndTar = this.getSourceAndTarget(graphRepationship),
        source = _this$getSourceAndTar[0],
        target = _this$getSourceAndTar[1];

    var relationship = new Relationship(alias, labels, source, target);
    relationship.id = id;
    relationship.properties = graphRepationship.properties ? this.propertyMapper.getPropertiesFromDto(graphRepationship.properties) : [];
    relationship.isOptional = graphRepationship.isOptional != null ? graphRepationship.isOptional : false;
    relationship.isReturnable = graphRepationship.isReturnable != null ? graphRepationship.isReturnable : true;
    return relationship;
  };

  _proto.getSourceAndTarget = function getSourceAndTarget(graphRepationship) {
    var source = this.entitiescreated.find(function (n) {
      return n.alias === graphRepationship.from || n.alias === graphRepationship.source;
    });
    var target = this.entitiescreated.find(function (n) {
      return n.alias === graphRepationship.to || n.alias === graphRepationship.target;
    });
    var isOptional = graphRepationship.isOptional != null ? graphRepationship.isOptional : false;

    if (!source && !target) {
      throw new Error('at least one of the relationship nodes (source or target) must exists in dtos list');
    } else {
      if (!source) {
        var aliasSource = graphRepationship.source || graphRepationship.from || '';
        source = this.buildStringNode(aliasSource, isOptional);
      }

      if (!target) {
        var aliasTarget = graphRepationship.target || graphRepationship.to || '';
        target = this.buildStringNode(aliasTarget, isOptional);
      }
    }

    return [source, target];
  };

  _proto.buildStringNode = function buildStringNode(aliasNode, isOptional) {
    var node = new Node(aliasNode, []);
    this.entitiescreated.push(node);
    node.isOptional = isOptional;
    return node;
  };

  return RelationshipMapper;
}();

var EntityMapper = /*#__PURE__*/function () {
  function EntityMapper() {
    this.nodeMapper = new NodeMapper();
    this.relationshipMapper = new RelationshipMapper();
    this.entitiescreated = [];
  }

  var _proto = EntityMapper.prototype;

  _proto.getEntitiesFromDtoArray = function getEntitiesFromDtoArray(inputDtos) {
    var _this = this;

    this.entitiescreated = [];

    var _this$getArrayOfGraph = this.getArrayOfGraphAbstraction(inputDtos),
        nodesGraphs = _this$getArrayOfGraph[0],
        relationshipGraphs = _this$getArrayOfGraph[1];

    var _loop = function _loop() {
      var dto = _step.value;

      var entity = _this.getInputNode(dto);

      var alreadyCreated = _this.entitiescreated.some(function (e) {
        return entity.id && e.id === entity.id || e.alias === entity.alias;
      });

      if (!alreadyCreated) {
        _this.entitiescreated.push(entity);
      }
    };

    for (var _iterator = _createForOfIteratorHelperLoose(nodesGraphs), _step; !(_step = _iterator()).done;) {
      _loop();
    }

    var _loop2 = function _loop2() {
      var dto = _step2.value;

      var entity = _this.getInputRelationship(dto);

      var alreadyCreated = _this.entitiescreated.some(function (e) {
        return entity.id && e.id === entity.id || e.alias === entity.alias;
      });

      if (!alreadyCreated) {
        _this.entitiescreated.push(entity);
      }
    };

    for (var _iterator2 = _createForOfIteratorHelperLoose(relationshipGraphs), _step2; !(_step2 = _iterator2()).done;) {
      _loop2();
    }

    return this.entitiescreated;
  };

  _proto.getArrayOfGraphAbstraction = function getArrayOfGraphAbstraction(inputDtos) {
    var aliasedGraph = Object.entries(inputDtos);

    for (var _i = 0, _aliasedGraph = aliasedGraph; _i < _aliasedGraph.length; _i++) {
      var entity = _aliasedGraph[_i];
      validateGraphEntity(entity[1]);
    }

    var nodesGraphs = aliasedGraph.filter(function (e) {
      return !(e[1].source || e[1].from) && !(e[1].target || e[1].to);
    });
    var relationshipGraphs = aliasedGraph.filter(function (e) {
      return e[1].source || e[1].from || e[1].target || e[1].to;
    });
    return [nodesGraphs, relationshipGraphs];
  };

  _proto.getInputNode = function getInputNode(_ref) {
    var alias = _ref[0],
        graphNode = _ref[1];
    var id = getId$1(graphNode);
    var found = this.wasEntityCreated(alias, id);
    if (found) return found;else return this.nodeMapper.getInputNode([alias, graphNode]);
  };

  _proto.getInputRelationship = function getInputRelationship(_ref2) {
    var alias = _ref2[0],
        graphRelationship = _ref2[1];
    var id = getId$1(graphRelationship);
    var found = this.wasEntityCreated(alias, id);
    if (found) return found;else return this.relationshipMapper.getInputRelationShipWithEntities([alias, graphRelationship], this.entitiescreated);
  };

  _proto.wasEntityCreated = function wasEntityCreated(alias, id) {
    var found;

    if (id) {
      found = this.entitiescreated.find(function (e) {
        return e.id == id;
      });
    }

    if (!found && alias) {
      found = this.entitiescreated.find(function (e) {
        return e.alias == alias;
      });
    }

    return found;
  };

  return EntityMapper;
}();

var ActionService = /*#__PURE__*/function () {
  function ActionService() {
    this.entityMapper = new EntityMapper();
    this.actionPort = new CypherActions();
  }

  var _proto = ActionService.prototype;

  _proto.findAll = function findAll(dto, page, size) {
    var entities = this.entityMapper.getEntitiesFromDtoArray(dto);
    var action = this.actionPort.generateRetrieveAction(entities, page, size);
    return action;
  };

  _proto.findOne = function findOne(dto) {
    var res = this.findAll(dto, 0, 1);
    return res;
  };

  return ActionService;
}();

var makeActionFunctionalService = function makeActionFunctionalService(actionService) {
  return Object.freeze({
    findAll: function findAll(entitiesPatternDto, page, size) {
      return actionService.findAll(entitiesPatternDto, page, size);
    },
    findOne: function findOne(entitiesPatternDto) {
      return actionService.findOne(entitiesPatternDto);
    }
  });
};
var actionFunctionalService = /*#__PURE__*/makeActionFunctionalService( /*#__PURE__*/new ActionService());
/**
 * Create a find all action that can be executed or used to generate a cypher string
 * The action will retrieve all instances matching the pattern given on the entities pattern dto
 * @param {GraphAbstraction} entitiesPatternDto - a dto which abstracts nodes and relationships
 * @param {number} [page] - If you want to use paginatiion you can send the page number to retrieve data
 * @param {number} [size] - If you want to use pagination you can send the size of your page
 * @return {DBAction}
 */

var findAll = actionFunctionalService.findAll;
/**
 * create a find one action that can be executed or used to generate a cypher string
 * The action will retrieve the first record matching the pattern given on the entities pattern dto
 * @param {GraphAbstraction} entitiesPatternDto - a dto which abstracts nodes and relationships
 * @return {DBAction}
 */

var findOne = actionFunctionalService.findOne;



var Neo4Ts = {
  __proto__: null,
  findAll: findAll,
  findOne: findOne
};



var DBAction$1 = {
  __proto__: null,
  DBAction: DBAction
};



var Neo4TSTypes = {
  __proto__: null
};



var Neo4TSEntities = {
  __proto__: null,
  Node: Node,
  Relationship: Relationship,
  get PropertyTypes () { return PropertyTypes; },
  get Condition () { return Condition; },
  get Operator () { return Operator; },
  Property: Property
};

/**
 * Close the driver connection
 */

var closeDriver = function closeDriver() {
  DriverAdapter.getInstance().closeDriver();
};
/**
 * Check if the Driver connection to DB is open
 * @returns {boolean}
 */

var isDriverOpen = function isDriverOpen() {
  return DriverAdapter.getInstance().isDriverOpen();
};

var ConfigurationManager$1 = {
  __proto__: null,
  closeDriver: closeDriver,
  isDriverOpen: isDriverOpen,
  setConfiguration: setConfiguration,
  getConfiguration: getConfiguration,
  ConfigurationManager: ConfigurationManager
};

export { DBAction$1 as Actions, ConfigurationManager$1 as ConfigManagers, Neo4Ts as Neo4TS, Neo4TSEntities, Neo4TSTypes };
//# sourceMappingURL=neo4ts.esm.js.map
