export declare enum PropertyTypes {
    INTEGER = "integer",
    FLOAT = "float",
    BOOLEAN = "boolean",
    STRING = "string",
    DATE = "date",
    TIME = "time",
    DATETIME = "datetime",
    ARRAY = "array"
}
export declare enum Condition {
    EQUAL = "equal",
    DIFFERENT = "different",
    CONTAINS = "contains",
    NOTCONTAINS = "notcontains",
    STARTS = "starts",
    ENDS = "ends",
    GREATER = "greater",
    GREATEREQUAL = "greaterequal",
    LOWER = "lower",
    LOWEREQUAL = "lowerequal",
    IN = "in",
    REVERSEIN = "reversein"
}
export declare enum Operator {
    AND = 0,
    OR = 1,
    XOR = 2,
    NOT = 3
}
export declare class Property {
    alias: string;
    type: PropertyTypes;
    value: string | number | boolean | Date | string[] | number[] | boolean[] | Date[] | Record<string, any>;
    condition: Condition;
    operator: Operator;
    isReturnable: boolean;
    isFilter: boolean;
    filterGroups: string[];
    constructor(alias: string, type: PropertyTypes, value: string | number | boolean | Date | string[] | number[] | boolean[] | Date[] | Record<string, any>);
}
