import * as Neo4JDriver from 'neo4j-driver';
export declare class DriverAdapter {
    private static instance;
    private driver;
    private configManager;
    private constructor();
    static getInstance(): DriverAdapter;
    /**
     * Check if the Driver connection to DB is open
     * @returns {boolean}
     */
    isDriverOpen(): boolean;
    /**
     * Open a new Driver connection to DB using the Neo4TS Configuration Manager, data to connect
     * @returns {Neo4JDriver.Driver}
     */
    openNewDriver(): Neo4JDriver.Driver;
    /**
     * Get a Driver connection, if it's not open it will open a new connection and return it
     * @returns {Neo4JDriver.Driver}
     */
    getDriver(): Neo4JDriver.Driver;
    /**
     * Close the driver connection
     */
    closeDriver(): void;
}
