import { GraphAbstraction } from '../../core/dtos/graph.abstraction.dto';
import { ActionService } from '../../core/services/action.service';
export declare const makeActionFunctionalService: (actionService: ActionService) => Readonly<{
    findAll: (entitiesPatternDto: GraphAbstraction, page?: number | undefined, size?: number | undefined) => import("./DBAction").DBAction;
    findOne: (entitiesPatternDto: GraphAbstraction) => import("./DBAction").DBAction;
}>;
/**
 * Create a find all action that can be executed or used to generate a cypher string
 * The action will retrieve all instances matching the pattern given on the entities pattern dto
 * @param {GraphAbstraction} entitiesPatternDto - a dto which abstracts nodes and relationships
 * @param {number} [page] - If you want to use paginatiion you can send the page number to retrieve data
 * @param {number} [size] - If you want to use pagination you can send the size of your page
 * @return {DBAction}
 */
export declare const findAll: (entitiesPatternDto: GraphAbstraction, page?: number | undefined, size?: number | undefined) => import("./DBAction").DBAction;
/**
 * create a find one action that can be executed or used to generate a cypher string
 * The action will retrieve the first record matching the pattern given on the entities pattern dto
 * @param {GraphAbstraction} entitiesPatternDto - a dto which abstracts nodes and relationships
 * @return {DBAction}
 */
export declare const findOne: (entitiesPatternDto: GraphAbstraction) => import("./DBAction").DBAction;
